﻿(function () {
    // Invoking JavaScript Strict Mode
    'use strict';
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Definition of the RazorEvents Application                                                                                                                                                         //
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    angular.module('RazorEvents', ['ui.bootstrap', 'toastr']);
    angular.module('RazorEvents')
        .config(function ($locationProvider, $compileProvider, toastrConfig) {
            $locationProvider.html5Mode(false);
            angular.extend(toastrConfig, {
                closeButton: true,
                containerId: 'toast-container',
                extendedTimeOut: 5000,
                progressBar: true,
                positionClass: 'toast-bottom-right',
                tapToDismiss: false,
                timeOut: 5000
            });
        })
        .filter('safeHtml', function ($sce) {
            return $sce.trustAsHtml;
        })
        .run(function ($rootScope, NgMap) {
            NgMap.getMap().then(function (map) {
                $rootScope.map = map;
            });
        })
        .controller('eventsCtrl', eventsCtrl)
        .requires.push('ngMap')
    ;
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Events Module Controller                                                                                                                                                                          //
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    function eventsCtrl($window, $scope, $rootScope, $element, $location, $http, $filter, $timeout, $q, $templateCache, $compile, $uibModal, toastr) {
        var vm = this;
        var sf = null;
        vm.init = function (model) {
            vm.moduleId = model.ModuleID;
            vm.moduleName = model.ModuleName;
            vm.event = model.Event;
            vm.category = model.Category;
            vm.location = model.Location;
            vm.images = model.Images;
            vm.localResource = model.LocalResource;
            vm.defaultImageSource = model.DefaultImageSource;
            sf = $.ServicesFramework(vm.moduleId);
            $element.attr('ng-init', '');
        };
        $scope.$watch(function () {
            return vm.event;
        }, function (newValue) {
            if (typeof newValue.Start === 'string')
                vm.event.Start = new Date(newValue.Start);
            if (typeof newValue.End === 'string')
                vm.event.End = new Date(newValue.End);
            if (angular.isArray(newValue.Repeats)) {
                for (var i in newValue.Repeats) {
                    if (typeof newValue.Repeats[i] === 'string')
                        vm.event.Repeats[i] = new Date(newValue.Repeats[i]);
                }
            }
        }, true);
        vm.navigateShareUrl = function ($event) {
            $event.preventDefault();
            var url = $event.currentTarget.getAttribute('href');
            var winWidth = Math.min(1000, screen.width - 15);
            var winHeight = Math.min(800, screen.height - 15);
            var winTop = screen.height / 2 - winHeight / 2;
            var winLeft = screen.width / 2 - winWidth / 2;
            window.open(url, 'Share-Product', 'width=' + winWidth + ',height=' + winHeight + ',top=' + winTop + ',left=' + winLeft + ',menubar=no,toolbar=no,status=no,resizable=yes,scrollbars=yes');
        };
    }
    // End of RazorEvents IIFE
}());